<?php
/**
 * Enter description here ...
 *
 * @package Logic
 *
 * @author  alessandrobartels
 *
 */
class INSS {


    /**
     * Enter description here ...
     *
     * @param integer               $incidencia      Incidencia.
     * @param integer               $evento          Evento.
     * @param integer               $evento_base     Evento Base.
     * @param TkDateTime            $mes_competencia Mes Competencia.
     * @param FpaitecalcfolhaEntity $item_de_calculo Item de Calculo.
     * @param FpaassoceventoEntity  $assoc_evento    Assoc_evento.
     * @param FpaeventomEntity      $eventom         Evento.
     * @param integer               $nrOrg           Numero da Organizacao.

     *
     * @return void
     *
     * @author alessandrobartels -
     *         alessandrobartels - 27/06/2011 - Implementacao do NRORG no metodo retornaEvento
     */
    public static function calcula(
        $incidencia, $evento, $evento_base, TkDateTime $mes_competencia, FpaitecalcfolhaEntity $item_de_calculo,
        FpaassoceventoEntity $assoc_evento, FpaeventomEntity $eventom, $nrOrg, $valorReferencia, $evento2Parte = null, $eventoConsulta = null,
        $proporcao = 0, $tipoVinculo = false
    ) {

        $base = $item_de_calculo->calculaIncidencias($incidencia, $mes_competencia, $eventom);

        $nrevento =  $assoc_evento->retornaEvento($evento_base, $nrOrg);
        $evento_base_inss = $eventom->retornaEvento($nrevento);
        // $item_de_calculo->geraEvento($evento_base_inss, $mes_competencia, $base, 0, 1);.
        $item_de_calculo->geraEvento($evento_base_inss, null, $base, 0, 1);
        $indice = $item_de_calculo->procuraEvento($evento_base_inss, $mes_competencia);
        /* Busca base novamente para aproveitar todo o tratamento generico do evento (centavos, valor negativo, etc.) */
        if ($indice !== -1) {
            $base = $item_de_calculo->retornaValor($indice);
        } else {
            $base = 0;
        }

        if ($tipoVinculo === false){
            $referencia = 0;
            $inss = FpafaixatabelaEntity::retornaValorProcessado(
                $base, FpatabelafolhaEntity::TAB_INSS, $mes_competencia, $referencia
            );
        } else {
            //BORBA 07/11/2014 Atendendo à solicitação 154473 Solicitei melhores inbformações sobre os tipos de inss possíveis fora da tabela CLT (ex.: Sócio/Autonomo/MenorAprendiz)
            //Foi criado um método que retorna a ultima faixa do INSS que tenha teto, pois coincide sempre com a referencia e teto aplicados a Autonomos e sócios.
            $referencia = 0;
            $inss = FpafaixatabelaEntity::retornaValorUltimaFaixa(
                $base, FpatabelafolhaEntity::TAB_INSS, $mes_competencia, $referencia
            );
            //$tetoValorInss=$valorReferencia->getValorReferencia(FpaValorreferenciamEntity::VALOR_TETO_INSS);
            //$percentualAutonomo = $valorReferencia->getValorReferencia(FpaValorreferenciamEntity::PERCENTUAL_INSS_AUTONOMO);
            //$inss = ($base * $percentualAutonomo) / 100;
            //if($inss>$tetoValorInss){
            //    $inss=$tetoValorInss;
            //}
        }

        /*$evento_inss_ja_desc = $assoc_evento->retornaEventoAssociado(
            FpatipoassoceveEntity::ASSOC_INSS_JA_DESC_CALC, $eventom, $nrOrg
        );*/
        $nrevento_ja_desc =  $assoc_evento->retornaEvento(FpatipoassoceveEntity::ASSOC_INSS_JA_DESC_CALC, $nrOrg);
        $evento_inss_ja_desc = $eventom->retornaEvento($nrevento_ja_desc);
        $indice = $item_de_calculo->procuraEvento($evento_inss_ja_desc, null);
        if ($indice !== -1) {
            $inss_ja_desc = $item_de_calculo->retornaValor($indice);
            $inss -= $inss_ja_desc;
        }

        
        // Gera evento de INSS segunda parte Ex.: INSS de Ferias 2a parte
        if (empty($evento2Parte) === false) {

            $nreventoConsulta =  $assoc_evento->retornaEvento($eventoConsulta, $nrOrg);
            $eventoConsulta = $eventom->retornaEvento($nreventoConsulta);
            $indice = $item_de_calculo->procuraEvento($eventoConsulta, null);
            if ($indice !== -1) {

                $nrevento2Parte =  $assoc_evento->retornaEvento($evento2Parte, $nrOrg);
                $eventoInss2Parte = $eventom->retornaEvento($nrevento2Parte);
                $inss2Parte = $inss * $proporcao;

                $item_de_calculo->geraEvento($eventoInss2Parte, null, $inss2Parte, $referencia, 1);

                $inss -= $inss2Parte;
            }
        }

        $nrevento =  $assoc_evento->retornaEvento($evento, $nrOrg);
        $evento_inss = $eventom->retornaEvento($nrevento);
        // $item_de_calculo->geraEvento($evento_inss, $mes_competencia, $inss, 0, 1);.
        $item_de_calculo->geraEvento($evento_inss, null, $inss, $referencia, 1);


    }


}