import { Http, IEventParam, Metadata } from '@zeedhi/core';
import {
  AlertService, Form, Modal, ModalService,
} from '@zeedhi/common';
import { ZdGrid } from '@zeedhi/vuetify';

export class Opl01600ParametrizacaoDoOPLController {
  private FiltroModal!: Modal;

  private Tab1AddModal!: Modal;

  private Tab1DeleteModal!: Modal;

  private Tab2AcrescentarModal!: Modal;

  private Tab2SubstituirModal!: Modal;

  private Tab2AddModal!: Modal;

  private Tab2DeleteModal!: Modal;

  private Tab3AddModal!: Modal;

  private Tab3DeleteModal!: Modal;

  public readOnlySubGrupProd: boolean = true;

  public filterValueCDFILIOPELOG: any = null;

  public filterValueCDFILIAL: Array<any> = [];

  public filterValueCDPRODINI: any = null;

  public filterValueCDPRODFIN: any = null;

  public filterValueCDMARCA: Array<any> = [];

  public filterValueCDSUBGRPPROD: Array<any> = [];

  public filterValuePARAMETRIZADO: any = 'Ambos';

  public filterValueIDITEMSEMPARAM: any = 'Não';

  public filterGrid2: any = {};

  public filterGrid3: any = {};

  public paraSupri: any = {};

  public async createFiltroModal() {
    this.FiltroModal = await ModalService.createFromJson('pages/opl01600/opl01600_parametrizacao_do_opl_filtro', true);

    this.Tab1AddModal = await ModalService.createFromJson('pages/opl01600/opl01600_parametrizacao_do_opl_tab1_modal1', true);

    this.Tab1DeleteModal = await ModalService.createFromJson('pages/opl01600/opl01600_parametrizacao_do_opl_tab1_modal2', true);

    this.Tab2AcrescentarModal = await ModalService.createFromJson('pages/opl01600/opl01600_parametrizacao_do_opl_tab2_modal1', true);

    this.Tab2SubstituirModal = await ModalService.createFromJson('pages/opl01600/opl01600_parametrizacao_do_opl_tab2_modal2', true);

    this.Tab2AddModal = await ModalService.createFromJson('pages/opl01600/opl01600_parametrizacao_do_opl_tab2_modal3', true);

    this.Tab2DeleteModal = await ModalService.createFromJson('pages/opl01600/opl01600_parametrizacao_do_opl_tab2_modal4', true);

    this.Tab3AddModal = await ModalService.createFromJson('pages/opl01600/opl01600_parametrizacao_do_opl_tab3_modal1', true);

    this.Tab3DeleteModal = await ModalService.createFromJson('pages/opl01600/opl01600_parametrizacao_do_opl_tab3_modal2', true);

    this.FiltroModal.show();

    Http.get('/crudN/parasupri?in=CDFILIAL&CDFILIAL=FILIAL_LOGADA').then((response) => {
      this.paraSupri = response.data.data[0];
    });
  }

  public destroyFiltroModal() {
    this.FiltroModal?.destroy();
  }

  public async abrirFiltroModal() {
    this.FiltroModal.show();
  }

  public fecharFiltroModal() {
    this.FiltroModal.hide();
  }

  public validaFiltro() {
    const form = Metadata.getInstance<Form>('formFiltro');
    const valid = form.validate();

    if (!valid) {
      AlertService.show({
        top: true,
        right: true,
        timeout: 2000,
        name: 'filtroInvalidoAltert',
        text: 'Preencha todos os campos obrigatórios!',
        color: 'error',
      });
    } else {
      form.submit();

      this.loadGrid1();

      this.fecharFiltroModal();
    }
  }

  public onChangeSwitchSubGrupProd({ component }: IEventParam<any>) {
    if (this.readOnlySubGrupProd) {
      this.filterValueCDSUBGRPPROD = [];
      component.parent.children.forEach((child: { name: any; value: any; }) => {
        if (child.name === 'CDSUBGRPROD') {
          child.value = [];
        }
      });
    }
  }

  public onChangeFieldsFiltro({ component }: IEventParam<any>) {
    switch (component.name) {
      case 'CDFILIOPELOG': {
        this.filterValueCDFILIOPELOG = component.value;
        break;
      }
      case 'CDFILIAL': {
        this.filterValueCDFILIAL = component.value;
        break;
      }
      case 'CDPRODINI': {
        this.filterValueCDPRODINI = component.value;
        break;
      }
      case 'CDPRODFIN': {
        this.filterValueCDPRODFIN = component.value;
        break;
      }
      case 'CDMARCA': {
        this.filterValueCDMARCA = component.value;
        break;
      }
      case 'CDSUBGRPROD': {
        this.filterValueCDSUBGRPPROD = component.value;
        break;
      }
      case 'PARAMETRIZADO': {
        this.filterValuePARAMETRIZADO = component.value;
        break;
      }
      case 'IDITEMSEMPARAM': {
        this.filterValueIDITEMSEMPARAM = component.value;
        break;
      }
      default: break;
    }
  }

  public onFilterOpen({ component }: IEventParam<any>) {
    const fieldCDFILIOPELOG = component.getChildInstance('CDFILIOPELOG');
    const fieldCDPRODINI = component.getChildInstance('CDPRODINI');
    const fieldCDPRODFIN = component.getChildInstance('CDPRODFIN');
    const fieldCDFILIAL = component.getChildInstance('CDFILIAL');
    const fieldCDMARCA = component.getChildInstance('CDMARCA');
    const fieldCDSUBGRPROD = component.getChildInstance('CDSUBGRPROD');

    fieldCDFILIOPELOG.setValue(this.filterValueCDFILIOPELOG != null ? this.filterValueCDFILIOPELOG.CDFILIAL : null);
    fieldCDPRODINI.setValue(this.filterValueCDPRODINI != null ? this.filterValueCDPRODINI.CDARVPROD : null);
    fieldCDPRODFIN.setValue(this.filterValueCDPRODFIN != null ? this.filterValueCDPRODFIN.CDARVPROD : null);

    const cdfiliais: any[] = [];
    const cdmarcas: any[] = [];
    const cdsubgrpprods: any[] = [];

    this.filterValueCDFILIAL.forEach((val) => {
      if (fieldCDFILIAL.value.indexOf(val.CDFILIAL) === -1) {
        cdfiliais.push(val.CDFILIAL);
      }
    });

    fieldCDFILIAL.setValue(cdfiliais.length > 0 ? cdfiliais : []);

    this.filterValueCDMARCA.forEach((val) => {
      if (fieldCDMARCA.value.indexOf(val.CDMARCA) === -1) {
        cdmarcas.push(val.CDMARCA);
      }
    });

    fieldCDMARCA.setValue(cdmarcas.length > 0 ? cdmarcas : []);

    this.filterValueCDSUBGRPPROD.forEach((val) => {
      if (fieldCDSUBGRPROD.value.indexOf(val.CDSUBGRPROD) === -1) {
        cdsubgrpprods.push(val.CDSUBGRPROD);
      }
    });

    fieldCDSUBGRPROD.setValue(cdsubgrpprods.length > 0 ? cdsubgrpprods : []);
  }

  public reload({ component }: any) {
    if (component.name === 'tipoOperacaoOLGrid' || component.parent.name === 'tipoOperacaoOLGrid') {
      component.parent.datasource.get();
    }

    if (component.name === 'parametrizacaoDeProdutoPorUnidadeGrid' || component.parent.name === 'parametrizacaoDeProdutoPorUnidadeGrid') {
      if (this.filterValueIDITEMSEMPARAM === 'Sim') {
        component.parent.datasource.route = '/crudN/opl01600_gridParametrizacaoDeProdutoPorUnidade';
      } else {
        component.parent.datasource.route = '/crudN/opl01600_gridParametrizacaoDeProdutoPorUnidadeNoPar';
      }

      component.parent.datasource.filter = this.filterGrid2;
      component.parent.datasource.get();
    }

    if (component.name === 'parametrizacaoGeralDeProdutosGrid' || component.parent.name === 'parametrizacaoGeralDeProdutosGrid') {
      if (this.filterValueIDITEMSEMPARAM === 'Sim') {
        component.parent.datasource.route = '/crudN/opl01600_gridTipoOperacaoOL';
      } else {
        component.parent.datasource.route = '/crudN/opl01600_gridTipoOperacaoOLNoPar';
      }

      component.parent.datasource.filter = this.filterGrid3;
      component.parent.datasource.get();
    }
  }

  public loadGrid1() {
    const grid = Metadata.getInstance<ZdGrid>('tipoOperacaoOLGrid');
    const arrayCDFILIAL: Array<any> = [];
    const arrayCDSUBGRPPROD: Array<any> = [];
    const arrayCDMARCA: Array<any> = [];
    let valueCDFILIAL: String = '';
    let valueCDSUBGRPPROD: String = '';
    let valueCDMARCA: String = '';

    this.filterValueCDFILIAL.forEach((val) => {
      arrayCDFILIAL.push(val.CDFILIAL);
    });
    valueCDFILIAL = String('_').concat(arrayCDFILIAL.join('_').concat(String('_')));

    this.filterValueCDSUBGRPPROD.forEach((val) => {
      arrayCDSUBGRPPROD.push(val.CDSUBGRPROD);
    });
    valueCDSUBGRPPROD = String('_').concat(arrayCDSUBGRPPROD.join('_').concat(String('_')));

    this.filterValueCDMARCA.forEach((val) => {
      arrayCDMARCA.push(val.CDMARCA);
    });
    valueCDMARCA = String('_').concat(arrayCDMARCA.join('_').concat(String('_')));

    const newFilter1 = {
      P_CDFILIAL: this.filterValueCDFILIAL.length > 0 ? valueCDFILIAL : 'T',
      P_OPERLOG: this.filterValueCDFILIOPELOG.CDFILIAL,
      P_CDOPERADOR: 'OPERADOR_LOGADO',
    };
    const newFilter2 = {
      P_NMPRODINI: this.filterValueCDPRODINI.NMPRODUTO,
      P_NMPRODFIN: this.filterValueCDPRODFIN.NMPRODUTO,
      P_CDFILIAL: this.filterValueCDFILIAL.length > 0 ? valueCDFILIAL : '',
      P_SUBGRUPO: this.filterValueCDSUBGRPPROD.length > 0 ? valueCDSUBGRPPROD : 'N',
      P_CDPRODINI: this.filterValueCDPRODINI.CDARVPROD,
      P_CDFILIOL: String('_').concat(String(this.filterValueCDFILIOPELOG.CDFILIAL).concat(String('_'))),
      P_TCDFILIOL: '',
      P_TCDFILIAL: this.filterValueCDFILIAL.length > 0 ? '' : 'T',
      P_CDPRODFIN: (String(this.filterValueCDPRODFIN.CDARVPROD).concat(String('ZZZZZZZZZZZZZZZZZZZZ'))).substr(0, 20),
      P_CDPRODFINTEXT: this.filterValueCDPRODFIN.CDARVPROD,
      P_IDUTLSUBGRPRODFIL: this.paraSupri.IDUTLSUBGRPRODFIL,
      P_CDFILIOPELOG: this.filterValueCDFILIOPELOG.CDFILIAL,
    };
    const newFilter21 = {
      P_NMPRODINI: this.filterValueCDPRODINI.NMPRODUTO,
      P_NMPRODFIN: this.filterValueCDPRODFIN.NMPRODUTO,
      P_CDFILIAL: this.filterValueCDFILIAL.length > 0 ? valueCDFILIAL : '',
      P_SUBGRUPO: this.filterValueCDSUBGRPPROD.length > 0 ? valueCDSUBGRPPROD : 'N',
      P_CDPRODINI: this.filterValueCDPRODINI.CDARVPROD,
      P_CDFILIOL: String('_').concat(String(this.filterValueCDFILIOPELOG.CDFILIAL).concat(String('_'))),
      P_TCDFILIOL: '',
      P_TCDFILIAL: this.filterValueCDFILIAL.length > 0 ? '' : 'T',
      P_CDPRODFIN: (String(this.filterValueCDPRODFIN.CDARVPROD).concat(String('ZZZZZZZZZZZZZZZZZZZZ'))).substr(0, 20),
      P_CDPRODFINTEXT: this.filterValueCDPRODFIN.CDARVPROD,
      P_IDUTLSUBGRPRODFIL: this.paraSupri.IDUTLSUBGRPRODFIL,
      P_CDFILIOPELOG: this.filterValueCDFILIOPELOG.CDFILIAL,
      P_CDGRUPPROD: this.paraSupri.CDGRUPPROD,
      P_CDGRUPAPRSOL: this.paraSupri.CDGRUPAPRSOL,
    };
    const newFilter3 = {
      P_CDFILIAL: 'FILIAL_LOGADA',
      P_SUBGRUPO: this.filterValueCDSUBGRPPROD.length > 0 ? valueCDSUBGRPPROD : 'N',
      P_CDMARCA: this.filterValueCDMARCA.length > 0 ? valueCDMARCA : 'T',
      P_CDPRODINI: this.filterValueCDPRODINI.CDARVPROD,
      P_CDPRODFIN: (String(this.filterValueCDPRODFIN.CDARVPROD).concat(String('ZZZZZZZZZZZZZZZZZZZZ'))).substr(0, 20),
      P_IDUTLSUBGRPRODFIL: this.paraSupri.IDUTLSUBGRPRODFIL,
      P_CDFILIOPELOG: this.filterValueCDFILIOPELOG.CDFILIAL,
    };

    if (this.filterValueIDITEMSEMPARAM === 'Sim') {
      grid.datasource.route = '/crudN/opl01600_gridTipoOperacaoOL';

      this.filterGrid2 = newFilter21;
      this.filterGrid3 = newFilter3;
    } else {
      grid.datasource.route = '/crudN/opl01600_gridTipoOperacaoOLNoPar';

      this.filterGrid2 = newFilter2;
      this.filterGrid3 = newFilter3;
    }

    grid.datasource.filter = newFilter1;
    grid.datasource.get();
  }

  public loadGrid2({ component }: any) {
    if (this.filterValueIDITEMSEMPARAM === 'Sim') {
      component.datasource.route = '/crudN/opl01600_gridParametrizacaoDeProdutoPorUnidade';
    } else {
      component.datasource.route = '/crudN/opl01600_gridParametrizacaoDeProdutoPorUnidadeNoPar';
    }

    component.datasource.filter = this.filterGrid2;
    component.datasource.get();
  }

  public loadGrid3({ component }: any) {
    if (this.filterValueIDITEMSEMPARAM === 'Sim') {
      component.datasource.route = '/crudN/opl01600_gridParametrizacaoGeralDeProdutos';
    } else {
      component.datasource.route = '/crudN/opl01600_gridParametrizacaoGeralDeProdutosNoPar';
    }

    component.datasource.filter = this.filterGrid3;
    component.datasource.get();
  }

  public abrirTab1AddModal() {
    this.Tab1AddModal.show();
  }

  public fecharTab1ModalAdd() {
    this.Tab1AddModal.hide();
  }

  public abrirTab1DeleteModal() {
    this.Tab1DeleteModal.show();
  }

  public fecharTab1ModalDelete() {
    this.Tab1DeleteModal.hide();
  }

  public async onTab1ModalAddOpen({ component }: IEventParam<any>) {
    const field = component.getChildInstance('CDFILIOPELOG');

    await field.setValue(this.filterValueCDFILIOPELOG.CDFILIAL);
  }

  public async onTab1ModalDeleteOpen({ component }: IEventParam<any>) {
    const field = component.getChildInstance('CDFILIOPELOG');

    await field.setValue(this.filterValueCDFILIOPELOG.CDFILIAL);
  }

  public abrirTab2AcrescentarModal() {
    this.Tab2AcrescentarModal.show();
  }

  public fecharTab2ModalAcrescentar() {
    this.Tab2AcrescentarModal.hide();
  }

  public abrirTab2SubstituirModal() {
    this.Tab2SubstituirModal.show();
  }

  public fecharTab2ModalSubstituir() {
    this.Tab2SubstituirModal.hide();
  }

  public abrirTab2AddModal() {
    this.Tab2AddModal.show();
  }

  public fecharTab2ModalAdd() {
    this.Tab2AddModal.hide();
  }

  public abrirTab2DeleteModal() {
    this.Tab2DeleteModal.show();
  }

  public fecharTab2ModalDelete() {
    this.Tab2DeleteModal.hide();
  }

  public async onTab2ModalAddOpen({ component }: IEventParam<any>) {
    const field = component.getChildInstance('CDFILIOPELOG');

    await field.setValue(this.filterValueCDFILIOPELOG.CDFILIAL);
  }

  public async onTab2ModalDeleteOpen({ component }: IEventParam<any>) {
    const field = component.getChildInstance('CDFILIOPELOG');

    await field.setValue(this.filterValueCDFILIOPELOG.CDFILIAL);
  }

  public tab2OnChangeRegiao({ component }: IEventParam<any>) {
    const form = component.parent;
    const fieldRegiao = component;
    const fieldUnidade = form.getChildInstance('CDFILIAL');

    fieldUnidade.setValue([]);

    if (fieldRegiao.value.length > 0) {
      const cdregioes: any[] = [];

      fieldRegiao.value.forEach((reg: any) => {
        cdregioes.push(reg.CDREGIAO);
      });

      fieldUnidade.datasource.filter.P_CDREGIAO = String('_').concat(String(cdregioes.join('_')).concat(String('_')));
    } else {
      fieldUnidade.datasource.filter.P_CDREGIAO = 'T';
    }

    fieldUnidade.datasource.get();
  }

  public abrirTab3AddModal() {
    this.Tab3AddModal.show();
  }

  public fecharTab3ModalAdd() {
    this.Tab3AddModal.hide();
  }

  public abrirTab3DeleteModal() {
    this.Tab3DeleteModal.show();
  }

  public fecharTab3ModalDelete() {
    this.Tab3DeleteModal.hide();
  }

  public async concluirTab1ModalAdd() {
    const form = Metadata.getInstance<Form>('formTab1ModalAdd');
    const valid = form.validate();
    const arrayCDFILIAL: Array<any> = [];
    let valueCDFILIAL: String = '';

    if (form.value.CDFILIAL.length > 0) {
      form.value.CDFILIAL.forEach((val: any) => {
        arrayCDFILIAL.push(val.CDFILIAL);
      });
      valueCDFILIAL = String('_').concat(arrayCDFILIAL.join('_').concat(String('_')));
    } else {
      valueCDFILIAL = 'T';
    }

    if (!valid) {
      AlertService.show({
        top: true,
        right: true,
        timeout: 2000,
        name: 'invalidoAltert',
        text: 'Preencha todos os campos obrigatórios!',
        color: 'error',
      });
    } else {
      form.submit();

      const row = {
        CDFILIOPELOG: form.value.CDFILIOPELOG.CDFILIAL,
        CDFILDEST: valueCDFILIAL,
        CDTIPOOPERSAID: form.value.CDTIPOOPERSAID.CDTIPOOPER,
        CDTIPOOPERENTR: form.value.CDTIPOOPERENTR.CDTIPOOPER,
      };

      await Http.post('/inclusaoAutTipoOperOPL', { requestType: 'Row', row }).then((response) => {
        if (response.data.error !== undefined) {
          AlertService.show({
            top: true,
            right: true,
            timeout: 2000,
            name: 'errorAlert',
            text: 'Não foi possível concluir o processo!<br>Por favor entre em contato com o Suporte Teknisa!',
            color: 'error',
          });
        } else if (response.data.dataset.data.P_ERROS === 'N') {
          AlertService.show({
            top: true,
            right: true,
            timeout: 2000,
            name: 'successAlert',
            text: 'Processo concluído com sucesso!',
            color: 'success',
          });

          this.fecharTab1ModalAdd();
        } else {
          AlertService.show({
            top: true,
            right: true,
            timeout: 2000,
            name: 'errorAlert',
            text: 'Não foi possível concluir o processo!<br>Não há dados!',
            color: 'error',
          });
        }
      });
    }
  }

  public async concluirTab1ModalDelete() {
    const form = Metadata.getInstance<Form>('formTab1ModalDelete');
    const valid = form.validate();
    const arrayCDFILIAL: Array<any> = [];
    let valueCDFILIAL: String = '';

    if (form.value.CDFILIAL.length > 0) {
      form.value.CDFILIAL.forEach((val: any) => {
        arrayCDFILIAL.push(val.CDFILIAL);
      });
      valueCDFILIAL = String('_').concat(arrayCDFILIAL.join('_').concat(String('_')));
    } else {
      valueCDFILIAL = 'T';
    }

    if (!valid) {
      AlertService.show({
        top: true,
        right: true,
        timeout: 2000,
        name: 'invalidoAltert',
        text: 'Preencha todos os campos obrigatórios!',
        color: 'error',
      });
    } else {
      form.submit();

      const row = {
        CDFILIOPELOG: form.value.CDFILIOPELOG.CDFILIAL,
        CDFILDEST: valueCDFILIAL,
      };

      await Http.post('/exclusaoAutTipoOperOPL', { requestType: 'Row', row }).then((response) => {
        if (response.data.error !== undefined) {
          AlertService.show({
            top: true,
            right: true,
            timeout: 2000,
            name: 'errorAlert',
            text: 'Não foi possível concluir o processo!<br>Por favor entre em contato com o Suporte Teknisa!',
            color: 'error',
          });
        } else if (response.data.dataset.data.P_ERROS === 'N') {
          AlertService.show({
            top: true,
            right: true,
            timeout: 2000,
            name: 'successAlert',
            text: 'Processo concluído com sucesso!',
            color: 'success',
          });

          this.fecharTab1ModalDelete();
        } else {
          AlertService.show({
            top: true,
            right: true,
            timeout: 2000,
            name: 'errorAlert',
            text: 'Não foi possível concluir o processo!<br>Não há dados!',
            color: 'error',
          });
        }
      });
    }
  }

  public async concluirTab2ModalAcrescentar() {
    const form = Metadata.getInstance<Form>('formTab2ModalAcrescentar');
    const valid = form.validate();
    const arrayCDFILIAL: Array<any> = [];
    let valueCDFILIAL: String = '';

    if (form.value.CDFILDEST.length > 0) {
      form.value.CDFILDEST.forEach((val: any) => {
        arrayCDFILIAL.push(val.CDFILIAL);
      });
      valueCDFILIAL = String('_').concat(arrayCDFILIAL.join('_').concat(String('_')));
    } else {
      valueCDFILIAL = 'T';
    }

    if (!valid) {
      AlertService.show({
        top: true,
        right: true,
        timeout: 2000,
        name: 'invalidoAltert',
        text: 'Preencha todos os campos obrigatórios!',
        color: 'error',
      });
    } else {
      form.submit();

      const row = {
        CDFILORIG: form.value.CDFILORIG.CDFILIAL,
        CDFILDEST: valueCDFILIAL,
      };

      await Http.post('/acrAutParamProdSupFili', { requestType: 'Row', row }).then((response) => {
        if (response.data.error !== undefined) {
          AlertService.show({
            top: true,
            right: true,
            timeout: 2000,
            name: 'errorAlert',
            text: 'Não foi possível concluir o processo!<br>Por favor entre em contato com o Suporte Teknisa!',
            color: 'error',
          });
        } else if (response.data.dataset.data.P_ERROS === 'N') {
          AlertService.show({
            top: true,
            right: true,
            timeout: 2000,
            name: 'successAlert',
            text: 'Processo concluído com sucesso!',
            color: 'success',
          });

          this.fecharTab2ModalAcrescentar();
        } else {
          AlertService.show({
            top: true,
            right: true,
            timeout: 2000,
            name: 'errorAlert',
            text: 'Não foi possível concluir o processo!<br>Não há dados!',
            color: 'error',
          });
        }
      });
    }
  }

  public async concluirTab2ModalSubstituir() {
    const form = Metadata.getInstance<Form>('formTab2ModalSubstituir');
    const valid = form.validate();
    const arrayCDFILIAL: Array<any> = [];
    let valueCDFILIAL: String = '';

    if (form.value.CDFILDEST.length > 0) {
      form.value.CDFILDEST.forEach((val: any) => {
        arrayCDFILIAL.push(val.CDFILIAL);
      });
      valueCDFILIAL = String('_').concat(arrayCDFILIAL.join('_').concat(String('_')));
    } else {
      valueCDFILIAL = 'T';
    }

    if (!valid) {
      AlertService.show({
        top: true,
        right: true,
        timeout: 2000,
        name: 'invalidoAltert',
        text: 'Preencha todos os campos obrigatórios!',
        color: 'error',
      });
    } else {
      form.submit();

      const row = {
        CDFILORIG: form.value.CDFILORIG.CDFILIAL,
        CDFILDEST: valueCDFILIAL,
      };

      await Http.post('/subAutParamProdSupFili', { requestType: 'Row', row }).then((response) => {
        if (response.data.error !== undefined) {
          AlertService.show({
            top: true,
            right: true,
            timeout: 2000,
            name: 'errorAlert',
            text: 'Não foi possível concluir o processo!<br>Por favor entre em contato com o Suporte Teknisa!',
            color: 'error',
          });
        } else if (response.data.dataset.data.P_ERROS === 'N') {
          AlertService.show({
            top: true,
            right: true,
            timeout: 2000,
            name: 'successAlert',
            text: 'Processo concluído com sucesso!',
            color: 'success',
          });

          this.fecharTab2ModalSubstituir();
        } else {
          AlertService.show({
            top: true,
            right: true,
            timeout: 2000,
            name: 'errorAlert',
            text: 'Não foi possível concluir o processo!<br>Não há dados!',
            color: 'error',
          });
        }
      });
    }
  }

  public async concluirTab2ModalAdd() {
    const form = Metadata.getInstance<Form>('formTab2ModalAdd');
    const valid = form.validate();
    const arrayCDFILIAL: Array<any> = [];
    const arrayCDREGIAO: Array<any> = [];
    const arrayCDSUBGRPPROD: Array<any> = [];
    let valueCDFILIAL: String = '';
    let valueCDREGIAO: String = '';
    let valueCDSUBGRPPROD: String = '';

    if (form.value.CDFILIAL.length > 0) {
      form.value.CDFILIAL.forEach((val: any) => {
        arrayCDFILIAL.push(val.CDFILIAL);
      });
      valueCDFILIAL = String('_').concat(arrayCDFILIAL.join('_').concat(String('_')));
    } else {
      valueCDFILIAL = 'T';
    }

    if (form.value.CDREGIAO.length > 0) {
      form.value.CDREGIAO.forEach((val: any) => {
        arrayCDREGIAO.push(val.CDFILIAL);
      });
      valueCDREGIAO = String('_').concat(arrayCDREGIAO.join('_').concat(String('_')));
    } else {
      valueCDREGIAO = 'T';
    }

    if (form.value.CDSUBGRPROD.length > 0) {
      form.value.CDSUBGRPROD.forEach((val: any) => {
        arrayCDSUBGRPPROD.push(val.CDSUBGRPROD);
      });
      valueCDSUBGRPPROD = String('_').concat(arrayCDSUBGRPPROD.join('_').concat(String('_')));
    } else {
      valueCDSUBGRPPROD = 'T';
    }

    if (!valid) {
      AlertService.show({
        top: true,
        right: true,
        timeout: 2000,
        name: 'invalidoAltert',
        text: 'Preencha todos os campos obrigatórios!',
        color: 'error',
      });
    } else {
      form.submit();

      const row = {
        CDFILIOPELOG: form.value.CDFILIOPELOG.CDFILIAL,
        CDREGIAO: valueCDREGIAO,
        CDFILIAL: valueCDFILIAL,
        CDGRUPPROD: this.paraSupri.CDGRUPPROD,
        CDSUBGRPROD: valueCDSUBGRPPROD,
        CDPRODINI: form.value.CDPRODINI.CDARVPROD,
        CDPRODFIN: (String(form.value.CDPRODFIN.CDARVPROD).concat(String('ZZZZZZZZZZZZZZZZZZZZ'))).substr(0, 20),
      };

      await Http.post('/inclusaoCadAutParamProdSup', { requestType: 'Row', row }).then((response) => {
        if (response.data.error !== undefined) {
          AlertService.show({
            top: true,
            right: true,
            timeout: 2000,
            name: 'errorAlert',
            text: 'Não foi possível concluir o processo!<br>Por favor entre em contato com o Suporte Teknisa!',
            color: 'error',
          });
        } else if (response.data.dataset.data.P_ERROS === 'N') {
          AlertService.show({
            top: true,
            right: true,
            timeout: 2000,
            name: 'successAlert',
            text: 'Processo concluído com sucesso!',
            color: 'success',
          });

          this.fecharTab2ModalAdd();
        } else {
          AlertService.show({
            top: true,
            right: true,
            timeout: 2000,
            name: 'errorAlert',
            text: 'Não foi possível concluir o processo!<br>Não há dados!',
            color: 'error',
          });
        }
      });
    }
  }

  public async concluirTab2ModalDelete() {
    const form = Metadata.getInstance<Form>('formTab2ModalDelete');
    const valid = form.validate();
    const arrayCDFILIAL: Array<any> = [];
    const arrayCDREGIAO: Array<any> = [];
    const arrayCDSUBGRPPROD: Array<any> = [];
    let valueCDFILIAL: String = '';
    let valueCDREGIAO: String = '';
    let valueCDSUBGRPPROD: String = '';

    if (form.value.CDFILIAL.length > 0) {
      form.value.CDFILIAL.forEach((val: any) => {
        arrayCDFILIAL.push(val.CDFILIAL);
      });
      valueCDFILIAL = String('_').concat(arrayCDFILIAL.join('_').concat(String('_')));
    } else {
      valueCDFILIAL = 'T';
    }

    if (form.value.CDREGIAO.length > 0) {
      form.value.CDREGIAO.forEach((val: any) => {
        arrayCDREGIAO.push(val.CDFILIAL);
      });
      valueCDREGIAO = String('_').concat(arrayCDREGIAO.join('_').concat(String('_')));
    } else {
      valueCDREGIAO = 'T';
    }

    if (form.value.CDSUBGRPROD.length > 0) {
      form.value.CDSUBGRPROD.forEach((val: any) => {
        arrayCDSUBGRPPROD.push(val.CDSUBGRPROD);
      });
      valueCDSUBGRPPROD = String('_').concat(arrayCDSUBGRPPROD.join('_').concat(String('_')));
    } else {
      valueCDSUBGRPPROD = 'T';
    }

    if (!valid) {
      AlertService.show({
        top: true,
        right: true,
        timeout: 2000,
        name: 'invalidoAltert',
        text: 'Preencha todos os campos obrigatórios!',
        color: 'error',
      });
    } else {
      form.submit();

      const row = {
        CDFILIOPELOG: form.value.CDFILIOPELOG.CDFILIAL,
        CDREGIAO: valueCDREGIAO,
        CDFILIAL: valueCDFILIAL,
        CDGRUPPROD: this.paraSupri.CDGRUPPROD,
        CDSUBGRPROD: valueCDSUBGRPPROD,
        CDPRODINI: form.value.CDPRODINI.CDARVPROD,
        CDPRODFIN: (String(form.value.CDPRODFIN.CDARVPROD).concat(String('ZZZZZZZZZZZZZZZZZZZZ'))).substr(0, 20),
      };

      await Http.post('/exclusaoCadAutParamProdSup', { requestType: 'Row', row }).then((response) => {
        if (response.data.error !== undefined) {
          AlertService.show({
            top: true,
            right: true,
            timeout: 2000,
            name: 'errorAlert',
            text: 'Não foi possível concluir o processo!<br>Por favor entre em contato com o Suporte Teknisa!',
            color: 'error',
          });
        } else if (response.data.dataset.data.P_ERROS === 'N') {
          AlertService.show({
            top: true,
            right: true,
            timeout: 2000,
            name: 'successAlert',
            text: 'Processo concluído com sucesso!',
            color: 'success',
          });

          this.fecharTab2ModalDelete();
        } else {
          AlertService.show({
            top: true,
            right: true,
            timeout: 2000,
            name: 'errorAlert',
            text: 'Não foi possível concluir o processo!<br>Não há dados!',
            color: 'error',
          });
        }
      });
    }
  }

  public async concluirTab3ModalAdd() {
    const form = Metadata.getInstance<Form>('formTab3ModalAdd');
    const valid = form.validate();
    const arrayCDMARCA: Array<any> = [];
    let valueCDFMARCA: String = '';

    if (form.value.CDMARCA.length > 0) {
      form.value.CDMARCA.forEach((val: any) => {
        arrayCDMARCA.push(val.CDFILIAL);
      });
      valueCDFMARCA = String('_').concat(arrayCDMARCA.join('_').concat(String('_')));
    } else {
      valueCDFMARCA = 'T';
    }

    if (!valid) {
      AlertService.show({
        top: true,
        right: true,
        timeout: 2000,
        name: 'invalidoAltert',
        text: 'Preencha todos os campos obrigatórios!',
        color: 'error',
      });
    } else {
      form.submit();

      const row = {
        CDPRODINIOL: form.value.CDPRODINIOL.CDARVPRODOL,
        CDPRODFINOL: (String(form.value.CDPRODFINOL.CDARVPRODOL).concat(String('ZZZZZZZZZZZZZZZZZZZZ'))).substr(0, 20),
        CDPRODINI: form.value.CDPRODINIORIG.CDARVPROD,
        CDPRODFIN: (String(form.value.CDPRODFINORIG.CDARVPROD).concat(String('ZZZZZZZZZZZZZZZZZZZZ'))).substr(0, 20),
        CDMARCA: valueCDFMARCA,
      };

      await Http.post('/inclusaoCadAutRelacProdOL', { requestType: 'Row', row }).then((response) => {
        if (response.data.error !== undefined) {
          AlertService.show({
            top: true,
            right: true,
            timeout: 2000,
            name: 'errorAlert',
            text: 'Não foi possível concluir o processo!<br>Por favor entre em contato com o Suporte Teknisa!',
            color: 'error',
          });
        } else if (response.data.dataset.data.P_ERROS === 'N') {
          AlertService.show({
            top: true,
            right: true,
            timeout: 2000,
            name: 'successAlert',
            text: 'Processo concluído com sucesso!',
            color: 'success',
          });

          this.fecharTab3ModalAdd();
        } else {
          AlertService.show({
            top: true,
            right: true,
            timeout: 2000,
            name: 'errorAlert',
            text: 'Não foi possível concluir o processo!<br>Não há dados!',
            color: 'error',
          });
        }
      });
    }
  }

  public async concluirTab3ModalDelete() {
    const form = Metadata.getInstance<Form>('formTab3ModalDelete');
    const valid = form.validate();

    if (!valid) {
      AlertService.show({
        top: true,
        right: true,
        timeout: 2000,
        name: 'invalidoAltert',
        text: 'Preencha todos os campos obrigatórios!',
        color: 'error',
      });
    } else {
      form.submit();

      const row = {
        CDPRODINIOL: form.value.CDPRODINIOL.CDARVPRODOL,
        CDPRODFINOL: (String(form.value.CDPRODFINOL.CDARVPRODOL).concat(String('ZZZZZZZZZZZZZZZZZZZZ'))).substr(0, 20),
      };

      await Http.post('/exclusaoCadAutRelacProdOL', { requestType: 'Row', row }).then((response) => {
        if (response.data.error !== undefined) {
          AlertService.show({
            top: true,
            right: true,
            timeout: 2000,
            name: 'errorAlert',
            text: 'Não foi possível concluir o processo!<br>Por favor entre em contato com o Suporte Teknisa!',
            color: 'error',
          });
        } else if (response.data.dataset.data.P_ERROS === 'N') {
          AlertService.show({
            top: true,
            right: true,
            timeout: 2000,
            name: 'successAlert',
            text: 'Processo concluído com sucesso!',
            color: 'success',
          });

          this.fecharTab3ModalDelete();
        } else {
          AlertService.show({
            top: true,
            right: true,
            timeout: 2000,
            name: 'errorAlert',
            text: 'Não foi possível concluir o processo!<br>Não há dados!',
            color: 'error',
          });
        }
      });
    }
  }
}
